## libopenshot 0.1.2+ds1

=== CMakeLists.txt ===
####################### CMakeLists.txt (libopenshot) #########################
# @brief CMake build file for libopenshot (used to generate makefiles)
# @author Jonathan Thomas <jonathan@openshot.org>
#
# @section LICENSE
#
# Copyright (c) 2008-2014 OpenShot Studios, LLC
# <http://www.openshotstudios.com/>. This file is part of
# OpenShot Library (libopenshot), an open-source project dedicated to 
# delivering high quality video editing and animation solutions to the 
# world. For more information visit <http://www.openshot.org/>.
#
# OpenShot Library (libopenshot) is free software: you can redistribute it
# and/or modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# OpenShot Library (libopenshot) is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
################################################################################

cmake_minimum_required(VERSION 2.8.11)

MESSAGE("--------------------------------------------------------------")
MESSAGE("Welcome to the OpenShot Build System! CMake will now check for all required build")
MESSAGE("dependencies and notify you of any missing files or other issues. If you have any")
MESSAGE("questions or issues, please visit <http://www.openshot.org/>.")

################ ADD CMAKE MODULES ##################
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/Modules")

################ GET VERSION INFORMATION FROM VERSION.H ##################
MESSAGE("--------------------------------------------------------------")
MESSAGE("Determining Version Number (from Version.h file)")

#### Get the lines related to libopenshot version from the Version.h header
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/include/Version.h OPENSHOT_VERSION_LINES
  REGEX "#define[ ]+OPENSHOT_VERSION_.*[0-9]+;.*")
  
#### Set each line into it's own variable
list (GET OPENSHOT_VERSION_LINES 0 LINE_MAJOR)
list (GET OPENSHOT_VERSION_LINES 1 LINE_MINOR)
list (GET OPENSHOT_VERSION_LINES 2 LINE_BUILD)
list (GET OPENSHOT_VERSION_LINES 3 LINE_SO)

#### Get the version number out of each line
STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_MAJOR.*([0-9])+;(.*)" "\\1" MAJOR_VERSION "${LINE_MAJOR}")
STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_MINOR.*([0-9])+;(.*)" "\\1" MINOR_VERSION "${LINE_MINOR}")
STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_BUILD.*([0-9])+;(.*)" "\\1" BUILD_VERSION "${LINE_BUILD}")
STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_SO.*([0-9])+;(.*)" "\\1" SO_VERSION "${LINE_SO}")
set(PROJECT_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${BUILD_VERSION}")

MESSAGE("--> MAJOR Version: ${MAJOR_VERSION}")
MESSAGE("--> MINOR Version: ${MINOR_VERSION}")
MESSAGE("--> BUILD Version: ${BUILD_VERSION}")
MESSAGE("--> SO/API/ABI Version: ${SO_VERSION}")
MESSAGE("--> VERSION: ${PROJECT_VERSION}")
MESSAGE("")

################### SETUP PROJECT ###################
PROJECT(openshot)
MESSAGE("--------------------------------------------------------------")
MESSAGE("Generating build files for ${PROJECT_NAME} (${PROJECT_VERSION})")

IF (WIN32)
	SET_PROPERTY(GLOBAL PROPERTY WIN32 "WIN32")
ENDIF(WIN32)

############## FIND ALL QT RELATED HEADERS ##############
set(QT_HEADER_DIR ${CMAKE_CURRENT_SOURCE_DIR}/include/Qt)
FILE(GLOB QT_HEADER_FILES "${QT_HEADER_DIR}/*.h")

############## PROCESS SUB-DIRECTORIES ##############
add_subdirectory(src)
add_subdirectory(tests)

################### DOCUMENTATION ###################
# Find Doxygen (used for documentation)
include(cmake/Modules/UseDoxygen.cmake)

file(GLOB_RECURSE doc_files ${CMAKE_CURRENT_BINARY_DIR}/doc/html/*.*)
INSTALL(FILES ${doc_files} DESTINATION share/doc/libopenshot)

=== src/CMakeLists.txt ===
####################### CMakeLists.txt (libopenshot) #########################
# @brief CMake build file for libopenshot (used to generate makefiles)
# @author Jonathan Thomas <jonathan@openshot.org>
#
# @section LICENSE
#
# Copyright (c) 2008-2014 OpenShot Studios, LLC
# <http://www.openshotstudios.com/>. This file is part of
# OpenShot Library (libopenshot), an open-source project dedicated to 
# delivering high quality video editing and animation solutions to the 
# world. For more information visit <http://www.openshot.org/>.
#
# OpenShot Library (libopenshot) is free software: you can redistribute it
# and/or modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# OpenShot Library (libopenshot) is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
################################################################################

################ OPTIONS ##################
# Optional build settings for libopenshot
OPTION(USE_SYSTEM_JSONCPP "Use system installed JsonCpp" OFF)

################ WINDOWS ##################
# Set some compiler options for Windows
# required for libopenshot-audio headers
IF (WIN32)
	add_definitions( -DIGNORE_JUCE_HYPOT=1 )
	SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -include cmath -std=c++0x")
ENDIF(WIN32)
IF (APPLE)
	# If you still get errors compiling with GCC 4.8, mac headers need to be patched: http://hamelot.co.uk/programming/osx-gcc-dispatch_block_t-has-not-been-declared-invalid-typedef/
    SET_PROPERTY(GLOBAL PROPERTY JUCE_MAC "JUCE_MAC")
    ADD_DEFINITIONS(-DNDEBUG)
    SET(EXTENSION "mm")
    
    SET(JUCE_PLATFORM_SPECIFIC_DIR build/macosx/platform_specific_code)
    SET(JUCE_PLATFORM_SPECIFIC_LIBRARIES "-framework Carbon -framework Cocoa -framework CoreFoundation -framework CoreAudio -framework CoreMidi -framework IOKit -framework AGL -framework AudioToolbox -framework QuartzCore -lobjc -framework Accelerate")

    SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -std=c++0x")
ENDIF(APPLE)

################ IMAGE MAGICK ##################
# Set the Quantum Depth that ImageMagick was built with (default to 16 bits)
IF (MAGICKCORE_QUANTUM_DEPTH)
	add_definitions( -DMAGICKCORE_QUANTUM_DEPTH=${MAGICKCORE_QUANTUM_DEPTH} )
ELSE (MAGICKCORE_QUANTUM_DEPTH)
	add_definitions( -DMAGICKCORE_QUANTUM_DEPTH=16 )
ENDIF (MAGICKCORE_QUANTUM_DEPTH)
IF (MAGICKCORE_HDRI_ENABLE)
	add_definitions( -DMAGICKCORE_HDRI_ENABLE=${MAGICKCORE_HDRI_ENABLE} )
ELSE (MAGICKCORE_HDRI_ENABLE)
	add_definitions( -DMAGICKCORE_HDRI_ENABLE=0 )
ENDIF (MAGICKCORE_HDRI_ENABLE)
IF (OPENSHOT_IMAGEMAGICK_COMPATIBILITY)
	add_definitions( -DOPENSHOT_IMAGEMAGICK_COMPATIBILITY=${OPENSHOT_IMAGEMAGICK_COMPATIBILITY} )
ELSE (OPENSHOT_IMAGEMAGICK_COMPATIBILITY)
	add_definitions( -DOPENSHOT_IMAGEMAGICK_COMPATIBILITY=0 )
ENDIF (OPENSHOT_IMAGEMAGICK_COMPATIBILITY)

# Find the ImageMagick++ library
FIND_PACKAGE(ImageMagick COMPONENTS Magick++ MagickWand MagickCore)
IF (ImageMagick_FOUND)
	# Include ImageMagick++ headers (needed for compile)
	include_directories(${ImageMagick_INCLUDE_DIRS})

	# define a global var (used in the C++)
	add_definitions( -DUSE_IMAGEMAGICK=1 )
	SET(CMAKE_SWIG_FLAGS "-DUSE_IMAGEMAGICK=1")

ENDIF (ImageMagick_FOUND)
	
################### FFMPEG #####################
# Find FFmpeg libraries (used for video encoding / decoding)
FIND_PACKAGE(FFmpeg REQUIRED)

# Include FFmpeg headers (needed for compile)
include_directories(${FFMPEG_INCLUDE_DIR})

################# LIBOPENSHOT-AUDIO ###################
# Find JUCE-based openshot Audio libraries
FIND_PACKAGE(OpenShotAudio REQUIRED)

message('LIBOPENSHOT_AUDIO_INCLUDE_DIRS: ${LIBOPENSHOT_AUDIO_INCLUDE_DIRS}')

# Include Juce headers (needed for compile)
include_directories(${LIBOPENSHOT_AUDIO_INCLUDE_DIRS})

################# QT5 ###################
# Find QT5 libraries
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Multimedia REQUIRED)
find_package(Qt5MultimediaWidgets REQUIRED)

# Include Qt headers (needed for compile)
include_directories(${Qt5Widgets_INCLUDE_DIRS})
include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Gui_INCLUDE_DIRS})
include_directories(${Qt5Multimedia_INCLUDE_DIRS})
include_directories(${Qt5MultimediaWidgets_INCLUDE_DIRS})

add_definitions(${Qt5Widgets_DEFINITIONS})
add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${Qt5Gui_DEFINITIONS})
add_definitions(${Qt5Multimedia_DEFINITIONS})
add_definitions(${Qt5MultimediaWidgets_DEFINITIONS})

SET(QT_LIBRARIES ${Qt5Widgets_LIBRARIES} 
				 ${Qt5Core_LIBRARIES}
				 ${Qt5Gui_LIBRARIES}
				 ${Qt5Multimedia_LIBRARIES}
				 ${Qt5MultimediaWidgets_LIBRARIES})

# Set compiler flags for Qt
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Multimedia_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5MultimediaWidgets_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -ggdb ")

# Manually moc Qt files
qt5_wrap_cpp(MOC_FILES ${QT_HEADER_FILES})

################# BLACKMAGIC DECKLINK ###################
# Find BlackMagic DeckLinkAPI libraries
IF (ENABLE_BLACKMAGIC)
	FIND_PACKAGE(BlackMagic)
	
	IF (BLACKMAGIC_FOUND)
		# Include headers (needed for compile)
		include_directories(${BLACKMAGIC_INCLUDE_DIR})
		
		# define a global var (used in the C++)
		add_definitions( -DUSE_BLACKMAGIC=1 )
		SET(CMAKE_SWIG_FLAGS "-DUSE_BLACKMAGIC=1")
		
	ENDIF (BLACKMAGIC_FOUND)
ENDIF (ENABLE_BLACKMAGIC)

################### OPENMP #####################
# Check for OpenMP (used for multi-core processing)
FIND_PACKAGE(OpenMP)

if (OPENMP_FOUND)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ")
endif(OPENMP_FOUND)

################### ZEROMQ #####################
# Find ZeroMQ library (used for socket communication & logging)
FIND_PACKAGE(ZMQ REQUIRED)

# Include FFmpeg headers (needed for compile)
include_directories(${ZMQ_INCLUDE_DIRS})

################### JSONCPP #####################
# Include jsoncpp headers (needed for JSON parsing)
if (USE_SYSTEM_JSONCPP)
	find_package(JsonCpp REQUIRED)
	include_directories(${JSONCPP_INCLUDE_DIRS})
else()
	message("Using embedded JsonCpp")
	include_directories("../thirdparty/jsoncpp/include")
endif(USE_SYSTEM_JSONCPP)

###############  PROFILING  #################
#set(PROFILER "/usr/lib/libprofiler.so.0.3.2")
#set(PROFILER "/usr/lib/libtcmalloc.so.4")

#### GET LIST OF EFFECT FILES ####
FILE(GLOB EFFECT_FILES "${CMAKE_CURRENT_SOURCE_DIR}/effects/*.cpp")

#### GET LIST OF QT PLAYER FILES ####
FILE(GLOB QT_PLAYER_FILES "${CMAKE_CURRENT_SOURCE_DIR}/Qt/*.cpp")

###############  SET LIBRARY SOURCE FILES  #################
SET ( OPENSHOT_SOURCE_FILES
  		AudioBufferSource.cpp
  		AudioReaderSource.cpp
		AudioResampler.cpp
		Cache.cpp
		ChunkReader.cpp
		ChunkWriter.cpp
		Color.cpp
		Clip.cpp
		ClipBase.cpp
		Coordinate.cpp
		DummyReader.cpp
		ReaderBase.cpp
		RendererBase.cpp
		WriterBase.cpp
		EffectBase.cpp
		${EFFECT_FILES}
		EffectInfo.cpp
		FFmpegReader.cpp
		FFmpegWriter.cpp
		Fraction.cpp
		Frame.cpp
		FrameMapper.cpp
		KeyFrame.cpp
		ZmqLogger.cpp
		PlayerBase.cpp
		Point.cpp
		Profiles.cpp
		QtImageReader.cpp
		QtPlayer.cpp
		Timeline.cpp
		
		# Qt Video Player
		${QT_PLAYER_FILES}
		${MOC_FILES})

		IF (NOT USE_SYSTEM_JSONCPP)
			# Third Party JSON Parser
			SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
				../thirdparty/jsoncpp/src/lib_json/json_reader.cpp
				../thirdparty/jsoncpp/src/lib_json/json_value.cpp
				../thirdparty/jsoncpp/src/lib_json/json_writer.cpp)
		ENDIF (NOT USE_SYSTEM_JSONCPP)

		# ImageMagic related files
		IF (ImageMagick_FOUND)
			SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES}
					ImageReader.cpp
					ImageWriter.cpp
					TextReader.cpp)
		ENDIF (ImageMagick_FOUND)

		# BlackMagic related files
		IF (BLACKMAGIC_FOUND)
			SET ( OPENSHOT_SOURCE_FILES ${OPENSHOT_SOURCE_FILES} 
				DecklinkInput.cpp
				DecklinkReader.cpp
				DecklinkOutput.cpp
				DecklinkWriter.cpp)
		ENDIF (BLACKMAGIC_FOUND)
		
		
# Get list of headers
file(GLOB_RECURSE headers ${CMAKE_SOURCE_DIR}/include/*.h)

# Disable RPATH
SET(CMAKE_MACOSX_RPATH 0)

############### CREATE LIBRARY #################
# Create shared openshot library
add_library(openshot SHARED 
			${OPENSHOT_SOURCE_FILES}
			${headers} )

# Set SONAME and other library properties
set_target_properties(openshot
			PROPERTIES
			VERSION ${PROJECT_VERSION}
			SOVERSION ${SO_VERSION} 
			INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
            )

###############  LINK LIBRARY  #################
SET ( REQUIRED_LIBRARIES
		${FFMPEG_LIBRARIES}
		${LIBOPENSHOT_AUDIO_LIBRARIES}
		${QT_LIBRARIES}
		${PROFILER}
		${JSONCPP_LIBRARY}
		${ZMQ_LIBRARIES}
		)
		
		IF (OPENMP_FOUND)
			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${OpenMP_CXX_FLAGS} )
		ENDIF (OPENMP_FOUND)
		
		IF (ImageMagick_FOUND)
			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${ImageMagick_LIBRARIES} )
		ENDIF (ImageMagick_FOUND)

		IF (BLACKMAGIC_FOUND)
			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${BLACKMAGIC_LIBRARY_DIR} )
		ENDIF (BLACKMAGIC_FOUND)

# Link all referenced libraries
target_link_libraries(openshot ${REQUIRED_LIBRARIES})


############### CLI EXECUTABLE ################
# Create test executable
add_executable(openshot-example examples/Example.cpp)

# Link test executable to the new library
target_link_libraries(openshot-example openshot)

############### PLAYER EXECUTABLE ################
# Create test executable
add_executable(openshot-player Qt/demo/main.cpp)

# Link test executable to the new library
target_link_libraries(openshot-player openshot)

############### TEST BLACKMAGIC CAPTURE APP ################
IF (BLACKMAGIC_FOUND)
	# Create test executable
	add_executable(openshot-blackmagic 
				   examples/ExampleBlackmagic.cpp)
	
	# Link test executable to the new library
	target_link_libraries(openshot-blackmagic openshot)
ENDIF (BLACKMAGIC_FOUND)

############### INCLUDE SWIG BINDINGS ################
add_subdirectory(bindings)


############### INSTALL HEADERS & LIBRARY ################
set(LIB_INSTALL_DIR lib${LIB_SUFFIX}) # determine correct lib folder

# Install primary library
INSTALL(  TARGETS openshot
  ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
  LIBRARY DESTINATION ${LIB_INSTALL_DIR}
  COMPONENT library )
	
INSTALL(FILES ${headers} 
	DESTINATION ${CMAKE_INSTALL_PREFIX}/include/libopenshot )


############### CPACK PACKAGING ##############
IF(MINGW)
	SET(CPACK_GENERATOR "NSIS")
ENDIF(MINGW)
IF(UNIX AND NOT APPLE)
	SET(CPACK_GENERATOR "DEB")
ENDIF(UNIX AND NOT APPLE)
#IF(UNIX AND APPLE)
#	SET(CPACK_GENERATOR "DragNDrop")
#ENDIF(UNIX AND APPLE)
SET(CPACK_DEBIAN_PACKAGE_MAINTAINER "Jonathan Thomas") #required

INCLUDE(CPack)

=== tests/CMakeLists.txt ===
##################### tests/CMakeLists.txt (libopenshot) ######################
# @brief CMake build file for libopenshot (used to generate makefiles)
# @author Jonathan Thomas <jonathan@openshot.org>
#
# @section LICENSE
#
# Copyright (c) 2008-2014 OpenShot Studios, LLC
# <http://www.openshotstudios.com/>. This file is part of
# OpenShot Library (libopenshot), an open-source project dedicated to 
# delivering high quality video editing and animation solutions to the 
# world. For more information visit <http://www.openshot.org/>.
#
# OpenShot Library (libopenshot) is free software: you can redistribute it
# and/or modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# OpenShot Library (libopenshot) is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
################################################################################


################ WINDOWS ##################
# Set some compiler options for Windows
# required for libopenshot-audio headers
IF (WIN32)
	STRING(REPLACE "/" "\\\\" TEST_MEDIA_PATH "${openshot_SOURCE_DIR}/src/examples/")
	add_definitions( -DIGNORE_JUCE_HYPOT=1 -DTEST_MEDIA_PATH="${TEST_MEDIA_PATH}" )
	SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -include cmath -std=c++0x")
ENDIF(WIN32)

################### UNITTEST++ #####################
# Find UnitTest++ libraries (used for unit testing)
FIND_PACKAGE(UnitTest++ REQUIRED)

# Include UnitTest++ headers (needed for compile)
include_directories(${UNITTEST++_INCLUDE_DIR})

################ IMAGE MAGICK ##################
# Set the Quantum Depth that ImageMagick was built with (default to 16 bits)
IF (MAGICKCORE_QUANTUM_DEPTH)
	add_definitions( -DMAGICKCORE_QUANTUM_DEPTH=${MAGICKCORE_QUANTUM_DEPTH} )
ELSE (MAGICKCORE_QUANTUM_DEPTH)
	add_definitions( -DMAGICKCORE_QUANTUM_DEPTH=16 )
ENDIF (MAGICKCORE_QUANTUM_DEPTH)
IF (MAGICKCORE_HDRI_ENABLE)
	add_definitions( -DMAGICKCORE_HDRI_ENABLE=${MAGICKCORE_HDRI_ENABLE} )
ELSE (MAGICKCORE_HDRI_ENABLE)
	add_definitions( -DMAGICKCORE_HDRI_ENABLE=0 )
ENDIF (MAGICKCORE_HDRI_ENABLE)
IF (OPENSHOT_IMAGEMAGICK_COMPATIBILITY)
	add_definitions( -DOPENSHOT_IMAGEMAGICK_COMPATIBILITY=${OPENSHOT_IMAGEMAGICK_COMPATIBILITY} )
ELSE (OPENSHOT_IMAGEMAGICK_COMPATIBILITY)
	add_definitions( -DOPENSHOT_IMAGEMAGICK_COMPATIBILITY=0 )
ENDIF (OPENSHOT_IMAGEMAGICK_COMPATIBILITY)

# Find the ImageMagick++ library
FIND_PACKAGE(ImageMagick COMPONENTS Magick++ MagickWand MagickCore)
IF (ImageMagick_FOUND)
	# Include ImageMagick++ headers (needed for compile)
	include_directories(${ImageMagick_INCLUDE_DIRS})

	# define a global var (used in the C++)
	add_definitions( -DUSE_IMAGEMAGICK=1 )
	SET(CMAKE_SWIG_FLAGS "-DUSE_IMAGEMAGICK=1")

ENDIF (ImageMagick_FOUND)

################### FFMPEG #####################
# Find FFmpeg libraries (used for video encoding / decoding)
FIND_PACKAGE(FFmpeg REQUIRED)

# Include FFmpeg headers (needed for compile)
include_directories(${FFMPEG_INCLUDE_DIR})

################# LIBOPENSHOT-AUDIO ###################
# Find JUCE-based openshot Audio libraries
FIND_PACKAGE(OpenShotAudio REQUIRED)

# Include Juce headers (needed for compile)
include_directories(${LIBOPENSHOT_AUDIO_INCLUDE_DIRS})

################# QT5 ###################
# Find QT5 libraries
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Multimedia REQUIRED)
find_package(Qt5MultimediaWidgets REQUIRED)

# Include Qt headers (needed for compile)
include_directories(${Qt5Widgets_INCLUDE_DIRS})
include_directories(${Qt5Core_INCLUDE_DIRS})
include_directories(${Qt5Gui_INCLUDE_DIRS})
include_directories(${Qt5Multimedia_INCLUDE_DIRS})
include_directories(${Qt5MultimediaWidgets_INCLUDE_DIRS})

add_definitions(${Qt5Widgets_DEFINITIONS})
add_definitions(${Qt5Core_DEFINITIONS})
add_definitions(${Qt5Gui_DEFINITIONS})
add_definitions(${Qt5Multimedia_DEFINITIONS})
add_definitions(${Qt5MultimediaWidgets_DEFINITIONS})

SET(QT_LIBRARIES ${Qt5Widgets_LIBRARIES} 
				 ${Qt5Core_LIBRARIES}
				 ${Qt5Gui_LIBRARIES}
				 ${Qt5Multimedia_LIBRARIES}
				 ${Qt5MultimediaWidgets_LIBRARIES})

# Set compiler flags for Qt
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Widgets_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Gui_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5Multimedia_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt5MultimediaWidgets_EXECUTABLE_COMPILE_FLAGS} ")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -ggdb ")

# Manually moc Qt files
qt5_wrap_cpp(MOC_FILES ${QT_HEADER_FILES})


################# BLACKMAGIC DECKLINK ###################
IF (ENABLE_BLACKMAGIC)
	# Find BlackMagic DeckLinkAPI libraries
	FIND_PACKAGE(BlackMagic)
	
	IF (BLACKMAGIC_FOUND)
		# Include Blackmagic headers (needed for compile)
		include_directories(${BLACKMAGIC_INCLUDE_DIR})
	ENDIF (BLACKMAGIC_FOUND)
ENDIF (ENABLE_BLACKMAGIC)

################### OPENMP #####################
# Check for OpenMP (used for multi-core processing)
FIND_PACKAGE(OpenMP)

if (OPENMP_FOUND)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ")
endif(OPENMP_FOUND)

################### ZEROMQ #####################
# Find ZeroMQ library (used for socket communication & logging)
FIND_PACKAGE(ZMQ REQUIRED)

# Include FFmpeg headers (needed for compile)
include_directories(${ZMQ_INCLUDE_DIRS})

################### JSONCPP #####################
# Include jsoncpp headers (needed for JSON parsing)
include_directories("../thirdparty/jsoncpp/include")

###############  SET TEST SOURCE FILES  #################
SET ( OPENSHOT_TEST_FILES tests.cpp )

IF (NOT DISABLE_TESTS)
	SET ( OPENSHOT_TEST_FILES ${OPENSHOT_TEST_FILES} 
		   Cache_Tests.cpp
		   Clip_Tests.cpp
		   Color_Tests.cpp
		   Coordinate_Tests.cpp
		   ReaderBase_Tests.cpp
		   ImageWriter_Tests.cpp
		   FFmpegReader_Tests.cpp
		   FFmpegWriter_Tests.cpp
		   Fraction_Tests.cpp
		   FrameMapper_Tests.cpp
		   KeyFrame_Tests.cpp
		   Point_Tests.cpp
		   Timeline_Tests.cpp )
ENDIF (NOT DISABLE_TESTS)

################ TESTER EXECUTABLE #################
# Create unit test executable (openshot-test)
add_executable(openshot-test
			   tests.cpp
			   ${OPENSHOT_TEST_FILES} )

# Link libraries to the new executable
target_link_libraries(openshot-test openshot ${UNITTEST++_LIBRARY})


#################### MAKE TEST ######################
# Hook up the 'make test' target to the 'openshot-test' executable
ADD_CUSTOM_TARGET(test ${CMAKE_CURRENT_BINARY_DIR}/openshot-test)

## libopenshot 0.1.2

=== debian/changelog ===
libopenshot (0.1.2-0obs) obs; urgency=medium

  * Rebuild for OBS.
  * Switch to 3.0 (quilt) source format.

 -- Steven Pusser (Stevo) <maintainer@mepiscommunity.org>  Thu, 01 Sep 2016 11:17:17 -0700

libopenshot (0.1.2-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Mon, 29 Aug 2016 23:54:57 -0500

libopenshot (0.1.1-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Jonathan Thomas <jonathan@openshot.org>  Sun, 27 Mar 2016 23:40:01 -0500

libopenshot (0.1.0-1) UNRELEASED; urgency=medium

  * New release. Fixed version # issue and documentation issue. 

 -- Jonathan Thomas <jonathan@os-phoenix>  Mon, 08 Feb 2016 21:54:25 -0600

libopenshot (0.0.9-1) UNRELEASED; urgency=low

  * Initial release. Closes: #810786

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 12 Jan 2016 16:23:48 +0000

=== debian/control ===
Source: libopenshot
Maintainer: Steven Pusser (Stevo) <maintainer@mepiscommunity.org>
Bugs: mailto: maintainer@mepiscommunity.org
XSBC-Original-Maintainer: Ghislain Antony Vaillant <ghisvail@gmail.com>
Section: libs
Priority: optional
Build-Depends: cmake (>= 2.8),
               debhelper (>= 9),
               libjpeg-dev,
               dh-python,
               libavcodec-dev,
               libavdevice-dev,
               libavfilter-dev,
               libavformat-dev,
               libavresample-dev,
               libavutil-dev,
               libjsoncpp-dev,
               libmagick++-dev,
               libopenshot-audio-dev,
               libswscale-dev,
               libunittest++-dev,
               libzmq3-dev,
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtmultimedia5-dev,
               swig
Build-Depends-Indep: doxygen
Standards-Version: 3.9.6
Homepage: http://www.openshot.org/

Package: libopenshot9
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Replaces: libopenshot8,
          libopenshot7,
          libopenshot6,
          libopenshot5,
          libopenshot4,
          libopenshot3,
          libopenshot2,
          libopenshot1
Description: library for high quality video editing
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the OpenShot library.

Package: libopenshot-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libopenshot9 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libopenshot-doc
Description: development files for the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the development files for the OpenShot library.

Package: libopenshot-doc
Architecture: all
Section: doc
Depends: libjs-jquery,
         ${misc:Depends}
Description: documentation of the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the documentation for the OpenShot library.

Package: python3-openshot
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python bindings for the OpenShot library
 Libopenshot is an open-source, cross-platform C++ library dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world.
 .
 This package provides the Python bindings for the OpenShot library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#DH_VERBOSE = 1

# Hardening flags.
export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Environment information.
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@ --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DUSE_SYSTEM_JSONCPP=ON

override_dh_auto_build-indep:
	dh_auto_build --indep -- doc

override_dh_install-arch:
	dh_install --arch
	dh_python3 --arch

override_dh_install-indep:
	dh_install --indep
	dh_doxygen --indep

override_dh_auto_test:

## libopenshot 0.1.2+ds1

=== debian/changelog ===
libopenshot (0.1.2+ds1-3build1) artful; urgency=medium

  * No-change rebuild to build with python3.6.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 24 Jul 2017 13:51:58 +0000

libopenshot (0.1.2+ds1-3) experimental; urgency=medium

  * Build depends on ImageMagick specifically
  * Fix arch-indep builds

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Wed, 01 Feb 2017 10:18:41 +0000

libopenshot (0.1.2+ds1-2) experimental; urgency=medium

  * Add missing build dependency on pkg-config
  * Drop versioned dependency on swig
  * Support the nodoc build profile
    - Add versioned build dependency on dpkg-dev
    - Mark documentation b-deps and packages as !nodoc
    - Do not build the documentation if nodoc is requested

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 31 Jan 2017 11:04:22 +0000

libopenshot (0.1.2+ds1-1) experimental; urgency=low

  * Initial release. (Closes: #810786)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Fri, 16 Dec 2016 12:41:46 +0000

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# Possible overlinkage.
# see: https://github.com/OpenShot/libopenshot/issues/38
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --with python3

override_dh_auto_configure:
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DUSE_SYSTEM_JSONCPP=ON

override_dh_auto_build-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	dh_auto_build -- doc
endif

override_dh_auto_test-indep:

override_dh_installdocs-indep:
ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
	dh_installdocs --indep
	dh_doxygen --indep
endif

=== debian/watch ===
version=3
opts=repacksuffix=+ds1,\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/libopenshot-$1\.tar\.gz/ \
https://github.com/OpenShot/libopenshot/tags .*/v?(\d\S*)\.tar\.gz

## libopenshot 0.1.9%2Bdfsg1

=== debian/changelog ===
libopenshot (0.1.9+dfsg1-3build1) bionic; urgency=medium

  * No-change rebuild against latest libopenshot-audio

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 22 Nov 2017 08:18:04 -0500

libopenshot (0.1.9+dfsg1-3) unstable; urgency=medium

  * Add new patch to really fix the FTBFS on arm64. (Closes: #879074)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 18 Nov 2017 14:50:58 +0100

libopenshot (0.1.9+dfsg1-2) unstable; urgency=medium

  * New patch to fix failing tests on some non-x86 architectures.
    (Closes: #879074, #879075)

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 18 Nov 2017 14:02:30 +0100

libopenshot (0.1.9+dfsg1-1) unstable; urgency=medium

  * New upstream version 0.1.9+dfsg1
  * Use 'dfsg' as repack suffix
  * Bump .so version to 14

 -- Dr. Tobias Quathamer <toddy@debian.org>  Wed, 15 Nov 2017 10:46:57 +0100

libopenshot (0.1.8+ds1-3) unstable; urgency=medium

  * Remove symbols file.
    The file makes the build fail on i386 and seems to be too
    fragile at the current stage to be included. Adding the
    file back might work later on, when upstream development
    has slowed down a bit.

 -- Dr. Tobias Quathamer <toddy@debian.org>  Sat, 28 Oct 2017 15:51:59 +0200

libopenshot (0.1.8+ds1-2) unstable; urgency=medium

  * Add symbols file
  * Update Standards-Version to 4.1.1, no changes needed

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 24 Oct 2017 21:22:19 +0200

libopenshot (0.1.8+ds1-1) unstable; urgency=medium

  * New upstream version 0.1.8+ds1
    - Fix FTBFS due to failing tests. Closes: #875969
  * Refresh patches
  * Bump soversion to 13
  * Adopt package. (Closes: #872904)
  * Update Standards-Version to 4.1.0

 -- Dr. Tobias Quathamer <toddy@debian.org>  Tue, 26 Sep 2017 16:55:53 +0200

libopenshot (0.1.7+ds1-1) experimental; urgency=medium

  * Switch from git-dpm to gbp
    - Drop git-dpm configuration
    - Unapply the patch queue
    - Add gbp configuration
    - Refresh the patch queue
    - Drop patch numbering
  * New upstream version 0.1.7+ds1
  * Rebase the patch queue
    - Drop Capture-multi-digit-version-numbers.patch, applied upstream
  * Bump soversion to 12
  * Update copyright information.
    Thanks to Chris Lamb (Closes: #855347)

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Tue, 13 Jun 2017 11:44:12 +0100

libopenshot (0.1.3+ds1-1) experimental; urgency=medium

  * New upstream release
  * Do not run `make install` in arch-indep builds
  * Bump soname of shlibs package to 10
  * Cherry-pick proposed fix for soversion parsing
    - New patch 0003-Capture-multi-digit-version-numbers.patch

 -- Ghislain Antony Vaillant <ghisvail@gmail.com>  Sat, 04 Feb 2017 14:26:25 +0000

## libopenshot 0.1.9+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,10 +49,10 @@
 list (GET OPENSHOT_VERSION_LINES 3 LINE_SO)
 
 #### Get the version number out of each line
-STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_MAJOR.*([0-9])+;(.*)" "\\1" MAJOR_VERSION "${LINE_MAJOR}")
-STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_MINOR.*([0-9])+;(.*)" "\\1" MINOR_VERSION "${LINE_MINOR}")
-STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_BUILD.*([0-9])+;(.*)" "\\1" BUILD_VERSION "${LINE_BUILD}")
-STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_SO.*([0-9])+;(.*)" "\\1" SO_VERSION "${LINE_SO}")
+STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_MAJOR[ ]+([0-9]+);(.*)" "\\1" MAJOR_VERSION "${LINE_MAJOR}")
+STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_MINOR[ ]+([0-9]+);(.*)" "\\1" MINOR_VERSION "${LINE_MINOR}")
+STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_BUILD[ ]+([0-9]+);(.*)" "\\1" BUILD_VERSION "${LINE_BUILD}")
+STRING(REGEX REPLACE "#define[ ]+OPENSHOT_VERSION_SO[ ]+([0-9]+);(.*)" "\\1" SO_VERSION "${LINE_SO}")
 set(PROJECT_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${BUILD_VERSION}")
 
 MESSAGE("--> MAJOR Version: ${MAJOR_VERSION}")
@@ -66,6 +66,9 @@
 PROJECT(openshot)
 MESSAGE("--------------------------------------------------------------")
 MESSAGE("Generating build files for ${PROJECT_NAME} (${PROJECT_VERSION})")
+
+#### Enable C++11 (for std::shared_ptr support)
+set(CMAKE_CXX_FLAGS "-std=c++11")
 
 IF (WIN32)
 	SET_PROPERTY(GLOBAL PROPERTY WIN32 "WIN32")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 # required for libopenshot-audio headers
 IF (WIN32)
 	add_definitions( -DIGNORE_JUCE_HYPOT=1 )
-	SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -include cmath -std=c++0x")
+	SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -include cmath")
 ENDIF(WIN32)
 IF (APPLE)
 	# If you still get errors compiling with GCC 4.8, mac headers need to be patched: http://hamelot.co.uk/programming/osx-gcc-dispatch_block_t-has-not-been-declared-invalid-typedef/
@@ -43,8 +43,6 @@
     
     SET(JUCE_PLATFORM_SPECIFIC_DIR build/macosx/platform_specific_code)
     SET(JUCE_PLATFORM_SPECIFIC_LIBRARIES "-framework Carbon -framework Cocoa -framework CoreFoundation -framework CoreAudio -framework CoreMidi -framework IOKit -framework AGL -framework AudioToolbox -framework QuartzCore -lobjc -framework Accelerate")
-
-    SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -std=c++0x")
 ENDIF(APPLE)
 
 ################ IMAGE MAGICK ##################
@@ -187,13 +185,16 @@
   		AudioBufferSource.cpp
   		AudioReaderSource.cpp
 		AudioResampler.cpp
-		Cache.cpp
+		CacheBase.cpp
+		CacheDisk.cpp
+		CacheMemory.cpp
 		ChunkReader.cpp
 		ChunkWriter.cpp
 		Color.cpp
 		Clip.cpp
 		ClipBase.cpp
 		Coordinate.cpp
+		CrashHandler.cpp
 		DummyReader.cpp
 		ReaderBase.cpp
 		RendererBase.cpp
@@ -287,6 +288,11 @@
 			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} ${BLACKMAGIC_LIBRARY_DIR} )
 		ENDIF (BLACKMAGIC_FOUND)
 
+		IF (WIN32)
+			# Required for exception handling on Windows
+			SET ( REQUIRED_LIBRARIES ${REQUIRED_LIBRARIES} "imagehlp" )
+		ENDIF(WIN32)
+
 # Link all referenced libraries
 target_link_libraries(openshot ${REQUIRED_LIBRARIES})

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,7 @@
 IF (WIN32)
 	STRING(REPLACE "/" "\\\\" TEST_MEDIA_PATH "${openshot_SOURCE_DIR}/src/examples/")
 	add_definitions( -DIGNORE_JUCE_HYPOT=1 -DTEST_MEDIA_PATH="${TEST_MEDIA_PATH}" )
-	SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -include cmath -std=c++0x")
+	SET(CMAKE_CXX_FLAGS " ${CMAKE_CXX_FLAGS} -include cmath")
 ENDIF(WIN32)
 
 ################### UNITTEST++ #####################
@@ -154,11 +154,9 @@
 # Include jsoncpp headers (needed for JSON parsing)
 include_directories("../thirdparty/jsoncpp/include")
 
-###############  SET TEST SOURCE FILES  #################
-SET ( OPENSHOT_TEST_FILES tests.cpp )
-
 IF (NOT DISABLE_TESTS)
-	SET ( OPENSHOT_TEST_FILES ${OPENSHOT_TEST_FILES} 
+	###############  SET TEST SOURCE FILES  #################
+	SET ( OPENSHOT_TEST_FILES tests.cpp
 		   Cache_Tests.cpp
 		   Clip_Tests.cpp
 		   Color_Tests.cpp
@@ -172,18 +170,18 @@
 		   KeyFrame_Tests.cpp
 		   Point_Tests.cpp
 		   Timeline_Tests.cpp )
-ENDIF (NOT DISABLE_TESTS)
 
-################ TESTER EXECUTABLE #################
-# Create unit test executable (openshot-test)
-add_executable(openshot-test
-			   tests.cpp
-			   ${OPENSHOT_TEST_FILES} )
+	################ TESTER EXECUTABLE #################
+	# Create unit test executable (openshot-test)
+	add_executable(openshot-test
+				   tests.cpp
+				   ${OPENSHOT_TEST_FILES} )
 
-# Link libraries to the new executable
-target_link_libraries(openshot-test openshot ${UNITTEST++_LIBRARY})
+	# Link libraries to the new executable
+	target_link_libraries(openshot-test openshot ${UNITTEST++_LIBRARY})
 
 
-#################### MAKE TEST ######################
-# Hook up the 'make test' target to the 'openshot-test' executable
-ADD_CUSTOM_TARGET(test ${CMAKE_CURRENT_BINARY_DIR}/openshot-test)
+	#################### MAKE TEST ######################
+	# Hook up the 'make test' target to the 'openshot-test' executable
+	ADD_CUSTOM_TARGET(test ${CMAKE_CURRENT_BINARY_DIR}/openshot-test)
+ENDIF (NOT DISABLE_TESTS)

=== src/bindings/python/CMakeLists.txt ===
####################### CMakeLists.txt (libopenshot) #########################
# @brief CMake build file for libopenshot (used to generate Python SWIG bindings)
# @author Jonathan Thomas <jonathan@openshot.org>
#
# @section LICENSE
#
# Copyright (c) 2008-2014 OpenShot Studios, LLC
# <http://www.openshotstudios.com/>. This file is part of
# OpenShot Library (libopenshot), an open-source project dedicated to 
# delivering high quality video editing and animation solutions to the 
# world. For more information visit <http://www.openshot.org/>.
#
# OpenShot Library (libopenshot) is free software: you can redistribute it
# and/or modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# OpenShot Library (libopenshot) is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
################################################################################


############### SWIG PYTHON BINDINGS ################
FIND_PACKAGE(SWIG 2.0 REQUIRED)
INCLUDE(${SWIG_USE_FILE})

FIND_PACKAGE(PythonLibs 3)
FIND_PACKAGE(PythonInterp 3)
IF (PYTHONLIBS_FOUND)
	IF (PYTHONINTERP_FOUND)

		### Include Python header files
		INCLUDE_DIRECTORIES(${PYTHON_INCLUDE_PATH})
		INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
		
		### Enable C++ support in SWIG
		SET_SOURCE_FILES_PROPERTIES(openshot.i PROPERTIES CPLUSPLUS ON)
		SET(CMAKE_SWIG_FLAGS "")
		
		### Add the SWIG interface file (which defines all the SWIG methods)
		SWIG_ADD_MODULE(openshot python openshot.i)

		### Link the new python wrapper library with libopenshot
		SWIG_LINK_LIBRARIES(openshot ${PYTHON_LIBRARIES} openshot)

		### FIND THE PYTHON INTERPRETER (AND THE SITE PACKAGES FOLDER)
		EXECUTE_PROCESS ( COMMAND ${PYTHON_EXECUTABLE} -c "import site; print(site.getsitepackages()[0])"
		                     OUTPUT_VARIABLE _ABS_PYTHON_MODULE_PATH
		                     OUTPUT_STRIP_TRAILING_WHITESPACE )
		GET_FILENAME_COMPONENT(_ABS_PYTHON_MODULE_PATH "${_ABS_PYTHON_MODULE_PATH}" ABSOLUTE)
		FILE(RELATIVE_PATH _REL_PYTHON_MODULE_PATH ${CMAKE_INSTALL_PREFIX} ${_ABS_PYTHON_MODULE_PATH})
		SET(PYTHON_MODULE_PATH ${_REL_PYTHON_MODULE_PATH})
		
		
		############### INSTALL HEADERS & LIBRARY ################
		### Install Python bindings
		INSTALL(TARGETS _openshot DESTINATION ${PYTHON_MODULE_PATH} )
		INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/openshot.py DESTINATION ${PYTHON_MODULE_PATH} )

	ENDIF(PYTHONINTERP_FOUND)
ENDIF (PYTHONLIBS_FOUND)

=== src/bindings/ruby/CMakeLists.txt ===
####################### CMakeLists.txt (libopenshot) #########################
# @brief CMake build file for libopenshot (used to generate Ruby SWIG bindings)
# @author Jonathan Thomas <jonathan@openshot.org>
#
# @section LICENSE
#
# Copyright (c) 2008-2014 OpenShot Studios, LLC
# <http://www.openshotstudios.com/>. This file is part of
# OpenShot Library (libopenshot), an open-source project dedicated to 
# delivering high quality video editing and animation solutions to the 
# world. For more information visit <http://www.openshot.org/>.
#
# OpenShot Library (libopenshot) is free software: you can redistribute it
# and/or modify it under the terms of the GNU Lesser General Public License
# as published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# OpenShot Library (libopenshot) is distributed in the hope that it will be
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with OpenShot Library. If not, see <http://www.gnu.org/licenses/>.
################################################################################


############### RUBY BINDINGS ################
FIND_PACKAGE(SWIG 2.0 REQUIRED)
INCLUDE(${SWIG_USE_FILE})

FIND_PACKAGE(Ruby)
IF (RUBY_FOUND)

	### Include the Ruby header files
	INCLUDE_DIRECTORIES(${RUBY_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
	
	### Enable C++ in SWIG
	SET_SOURCE_FILES_PROPERTIES(openshot.i PROPERTIES CPLUSPLUS ON)
	SET(CMAKE_SWIG_FLAGS "")

	### Add the SWIG interface file (which defines all the SWIG methods)
	SWIG_ADD_MODULE(rbopenshot ruby openshot.i)
	
	### Set name of target (with no prefix, since Ruby does not like that)
	SET_TARGET_PROPERTIES(rbopenshot PROPERTIES PREFIX "" OUTPUT_NAME "openshot")

	### Link the new Ruby wrapper library with libopenshot
	SWIG_LINK_LIBRARIES(rbopenshot ${RUBY_LIBRARY} openshot)
	
	### FIND THE RUBY INTERPRETER (AND THE LOAD_PATH FOLDER)
	EXECUTE_PROCESS(COMMAND ${RUBY_EXECUTABLE} -r rbconfig -e "print RbConfig::CONFIG['vendorarchdir']" OUTPUT_VARIABLE RUBY_VENDOR_ARCH_DIR)
	MESSAGE(STATUS "Ruby executable: ${RUBY_EXECUTABLE}")
	MESSAGE(STATUS "Ruby vendor arch dir: ${RUBY_VENDOR_ARCH_DIR}")
	MESSAGE(STATUS "Ruby include path: ${RUBY_INCLUDE_PATH}")
	

	############### INSTALL HEADERS & LIBRARY ################
	# Install Ruby bindings
	INSTALL(TARGETS rbopenshot LIBRARY DESTINATION ${RUBY_VENDOR_ARCH_DIR})
	
ENDIF (RUBY_FOUND)

=== debian/control ===
Source: libopenshot
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Dr. Tobias Quathamer <toddy@debian.org>
Section: libs
Priority: optional
Build-Depends: cmake,
               debhelper (>= 10),
               dh-python,
               dpkg-dev (>= 1.17.14),
               ffmpeg,
               libavcodec-dev,
               libavdevice-dev,
               libavformat-dev,
               libavresample-dev,
               libavutil-dev,
               libjsoncpp-dev,
               libmagick++-6.q16-dev,
               libopenshot-audio-dev,
               libswscale-dev,
               libunittest++-dev,
               libzmq3-dev,
               pkg-config,
               python3-dev,
               qtbase5-dev,
               qtmultimedia5-dev,
               swig
Build-Depends-Indep: doxygen <!nodoc>
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-multimedia/libopenshot.git/
Vcs-Git: https://anonscm.debian.org/git/pkg-multimedia/libopenshot.git
Homepage: http://www.openshot.org/

Package: libopenshot14
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for high-quality video editing
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the shared libraries.

Package: libopenshot-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends},
         libopenshot14 (= ${binary:Version})
Suggests: libopenshot-doc <!nodoc>
Description: development files for the OpenShot video library
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the development files.

Package: libopenshot-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: documentation for the OpenShot video library
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the documentation.
Build-Profiles: <!nodoc>

Package: python3-openshot
Architecture: any
Multi-Arch: same
Section: python
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: OpenShot video library bindings for Python 3
 OpenShot Library (libopenshot) is an open-source project dedicated to
 delivering high quality video editing, animation, and playback solutions
 to the world. The API currently supports C++, Python, and Ruby.
 .
 This package provides the bindings for Python 3.

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,8 @@
 
 override_dh_auto_test-indep:
 
+override_dh_auto_install-indep:
+
 override_dh_installdocs-indep:
 ifeq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
 	dh_installdocs --indep
